class GenericArray<T> {
  private T[] array;
  public GenericArray(int sz) {
    array = (T[])new Object[sz];
  }
  public void put(int index, T item) {
    array[index] = item;
  }
  public T get(int index) { return array[index]; }
  // ,     
  public T[] rep() { return array; }	
}

class GenericArray2<T> {
	  private Object[] array;
	  public GenericArray2(int sz) {
	    array = new Object[sz];
	  }
	  public void put(int index, T item) {
	    array[index] = item;
	  }
	  public T get(int index) { return (T)array[index]; }
	  public T[] rep() {
	    return (T[])array; // :  
	  }
}

public class Example10c {
	public static void main(String[] args) {
	    GenericArray<Integer> gai =
	    	      new GenericArray<Integer>(10);
 	    //   ClassCastException:
   	    Integer[] ia = gai.rep();
   	    //   
   	    Object[] oa = gai.rep();
   	    
   	    GenericArray2<Integer> gai2 =
   	         new GenericArray2<Integer>(10);
   	    
   	 //   ClassCastException:
        Integer[] ia2 = gai2.rep();
	}
}
