import java.util.ArrayList;

class Fruit {}
class Apple extends Fruit {}
class Jonathan extends Apple {}
class Orange extends Fruit {}

public class Example12 {
	public static void print(ArrayList<? extends Fruit> af) {
		for (Fruit f : af) {
			System.out.println(f);
		}
	}
	
	public static void main(String[] args) {
	    Fruit[] fruit = new Apple[10];
	    fruit[0] = new Apple(); // OK
	    fruit[1] = new Jonathan(); // OK
	    fruit[2] = new Fruit(); // ArrayStoreException
	    fruit[3] = new Orange(); // ArrayStoreException
	    
	    //!
	    //ArrayList<Fruit> af = new ArrayList<Apple>();
	    ArrayList<? extends Fruit> af = new ArrayList<Apple>();
	    //af.add(new Fruit());
	    //af.add(new Apple());
	    af.add(null);
	    
	}
}
